<script setup lang="ts">
    import {
        ref,
        computed,
        WritableComputedRef,
        ComputedRef,
        watchEffect,
    } from 'vue'
    import SMapPicker from '@/shared/map/components/SMapPicker.vue'
    import { VForm } from 'vuetify/lib/components/index.mjs'

    import { interventionServiceOfferInjectionKey } from '@/interventionServiceOffer/constants'
    import { InterventionPriority } from '@/interventionServiceOffer/entities/intervention/InterventionDto'
    import { Intervention } from '@/interventionServiceOffer/entities/intervention/Intervention'
    import {
        HiddenFields,
        isDefined,
        isUndefined,
        requiredInject,
    } from '@/shared/helpers/types'
    import { Equipement } from '@/interventionServiceOffer/entities/equipement/Equipement'
    import { truncateWithEllipsis } from '@/shared/helpers/strings'
    import { LatLngLiteral } from 'leaflet'
    import SDateRangeField from '@/shared/formField/components/SDateRangeField.vue'

    const interventionServiceOffer = requiredInject(
        interventionServiceOfferInjectionKey
    )

    interface Props {
        availableEquipements?: Equipement[]
        isLoadingAvailableEquipements?: boolean
        hiddenFields?: { [Property in keyof Intervention]?: true }
    }

    function isDisplayed(fields: keyof Intervention) {
        return (
            hiddenFieldsAvecGestionDesDatesSurchargéesDepuisOds.value?.[
                fields
            ] !== true
        )
    }

    const props = withDefaults(defineProps<Props>(), {
        availableEquipements: () => [],
        isLoadingAvailableEquipements: false,
        hiddenFields: () => ({}),
    })

    const hiddenFieldsAvecGestionDesDatesSurchargéesDepuisOds = computed<
        HiddenFields<Intervention>
    >(() => {
        return {
            ...props.hiddenFields,
            dateDeDebut:
                props.hiddenFields?.dateDeDebut ||
                !interventionServiceOffer.value?.data
                    ?.gestionDatesPourInterventionActif ||
                undefined,
            dateDeFin:
                props.hiddenFields?.dateDeFin ||
                !interventionServiceOffer.value?.data
                    ?.gestionDatesPourInterventionActif ||
                undefined,
        }
    })

    const intervention = defineModel<Partial<Intervention>>({
        required: true,
    })

    const mapPickerRef = ref<InstanceType<typeof SMapPicker> | undefined>(
        undefined
    )

    const autoTitleEnabled = ref<boolean>(isUndefined(intervention.value.title))

    const autoTitle: ComputedRef<string> = computed(() => {
        const autoTitleArray = []
        if (isDefined(intervention.value.actionType?.label)) {
            autoTitleArray.push(intervention.value.actionType.label)
        }

        if (isDefined(intervention.value.relatedEquipement?.label)) {
            autoTitleArray.push(intervention.value.relatedEquipement.label)
        }

        if (isDefined(intervention.value.description)) {
            autoTitleArray.push(intervention.value.description)
        }

        const autoTitleUnsafe = autoTitleArray.join(' ')

        return truncateWithEllipsis(autoTitleUnsafe, titleMaxLenght)
    })

    const customTitle = ref(intervention.value.title ?? '')

    const interventionTitle: WritableComputedRef<string> = computed({
        get() {
            return autoTitleEnabled.value ? autoTitle.value : customTitle.value
        },
        set(title: string) {
            if (!autoTitleEnabled.value) {
                customTitle.value = title
            }
        },
    })

    watchEffect(() => {
        intervention.value.title = interventionTitle.value
    })

    const actionType = computed({
        get: () => {
            return intervention.value.actionType?.id
        },
        set: (actionTypeId?: Required<Intervention>['actionType']['id']) => {
            intervention.value.actionType = isDefined(actionTypeId)
                ? {
                      id: actionTypeId,
                      label:
                          interventionServiceOffer.value?.data
                              ?.gmaoConfiguration.actionTypesMap[
                              actionTypeId
                          ] ?? '',
                  }
                : undefined
        },
    })

    const titleMaxLenght = 60
    const descriptionMaxLenght = 500

    const nativformFieldsAreValid = ref<boolean>(false)
    const mapPickerIsValid = ref<boolean>(false)
    const formFieldsAreValid = computed<boolean>(() => {
        return (
            nativformFieldsAreValid.value &&
            (isDisplayed('coordinates') ? mapPickerIsValid.value : true)
        )
    })
    const rules = {
        hasTitle: (input: string | undefined) => {
            const isValid = !!input
            return isValid || 'Le titre est obligatoire.'
        },
        hasShortEnoughDescriptionIfFilled: (input: string | undefined) => {
            const isValid =
                input === undefined || input.length <= descriptionMaxLenght
            return (
                isValid ||
                'Votre description ne doit pas dépasser plus de ' +
                    descriptionMaxLenght +
                    ' caractères'
            )
        },

        hasRelatedEquipement: (input: string | undefined | null) => {
            if (props.availableEquipements.length !== 0) {
                return (
                    !!input || "Vous devez préciser le lieu de l'intervention"
                )
            }
            return true
        },
        hasPositionIfNoAvailableEquipment: (
            coordonnée: LatLngLiteral | undefined
        ) => {
            const isValid =
                props.availableEquipements.length !== 0 ||
                isDefined(intervention.value.relatedEquipement)
                    ? true
                    : isDefined(coordonnée)

            mapPickerIsValid.value = isValid
            return isValid || "Vous devez localiser l'intervention"
        },
        hasDateDeDebut: (input: Date | undefined) => {
            return isDefined(input) || 'La date de début est obligatoire.'
        },
        hasDateDeFin: (input: Date | undefined) => {
            return isDefined(input) || 'La date de fin est obligatoire.'
        },
    }
    defineExpose({ formFieldsAreValid, autoTitleEnabled })
</script>

<template>
    <v-form v-model="nativformFieldsAreValid">
        <v-row>
            <v-col
                v-if="
                    isDisplayed('relatedEquipement') ||
                    isDisplayed('coordinates')
                "
                cols="12"
            >
                <h6 class="text-h6 mb-2">Localisation*</h6>
                <v-autocomplete
                    v-if="isDisplayed('relatedEquipement')"
                    v-model="intervention.relatedEquipement"
                    return-object
                    auto-select-first
                    data-cy="select-equipement"
                    label="Equipement"
                    :loading="isLoadingAvailableEquipements"
                    :items="availableEquipements"
                    :disabled="availableEquipements.length < 2"
                    :hint="
                        availableEquipements.length === 0
                            ? 'Il n\'y a pas d\'équipement permettant la création d\'interventions, veuillez sélectionner la position sur la carte'
                            : undefined
                    "
                    persistent-hint
                    class="mb-3"
                    item-title="label"
                    item-value="id"
                    variant="outlined"
                    placeholder="Localisation"
                    :rules="[rules.hasRelatedEquipement]"
                ></v-autocomplete>
                <s-map-picker
                    v-if="isDisplayed('coordinates')"
                    ref="mapPickerRef"
                    v-model="intervention.coordinates"
                    height="400px"
                    :prevent-drag="true"
                    :rules="[
                        rules.hasPositionIfNoAvailableEquipment(
                            intervention.coordinates
                        ),
                    ]"
                />
            </v-col>
            <v-col cols="12">
                <template
                    v-if="
                        interventionServiceOffer?.accessGranted &&
                        isDisplayed('actionType') &&
                        Object.keys(
                            interventionServiceOffer.data.gmaoConfiguration
                                .actionTypesMap
                        ).length > 0
                    "
                >
                    <h6 class="text-h6">Nature</h6>
                    <v-chip-group
                        v-model="actionType"
                        selected-class="text-primary"
                        column
                        class="text-capitalize"
                        mandatory="force"
                    >
                        <v-chip
                            v-for="(
                                actionTypeValue, actionTypeKey
                            ) in interventionServiceOffer.data.gmaoConfiguration
                                .actionTypesMap"
                            :key="actionTypeKey"
                            :value="actionTypeKey"
                            data-cy="action-type"
                        >
                            {{ actionTypeValue }}
                        </v-chip>
                    </v-chip-group>
                </template>
                <template v-if="isDisplayed('priority')">
                    <h6 class="text-h6">Priorité</h6>
                    <v-chip-group
                        v-model="intervention.priority"
                        selected-class="text-primary"
                        column
                        class="text-capitalize"
                        mandatory="force"
                    >
                        <v-chip
                            v-for="availablePriority in Object.values(
                                InterventionPriority
                            ).map((priority) => priority)"
                            :key="availablePriority"
                            :value="availablePriority"
                            :data-cy="`priority-${availablePriority}`"
                        >
                            {{ availablePriority }}
                        </v-chip>
                    </v-chip-group>
                </template>
            </v-col>
            <v-col
                v-if="isDisplayed('title') || isDisplayed('description')"
                cols="12"
            >
                <h6 class="text-h6 mb-2">Instructions</h6>

                <v-textarea
                    v-if="isDisplayed('description')"
                    v-model="intervention.description"
                    data-cy="description"
                    label="Description"
                    variant="outlined"
                    class="mt-3"
                    :counter="descriptionMaxLenght"
                    :rules="[rules.hasShortEnoughDescriptionIfFilled]"
                    auto-grow
                ></v-textarea>
                <div v-if="isDisplayed('title')">
                    <div class="d-flex align-center">
                        <span class="me-3"
                            >Génération automatique du titre</span
                        >
                        <v-switch
                            v-model="autoTitleEnabled"
                            hide-details
                            color="primary"
                            data-cy="switch-auto-title"
                            class="flex-row-reverse"
                        ></v-switch>
                    </div>
                    <v-text-field
                        v-model="interventionTitle"
                        :disabled="autoTitleEnabled"
                        data-cy="titre-de-l-intervention"
                        label="Titre*"
                        :persistent-hint="autoTitleEnabled"
                        :hint="
                            autoTitleEnabled
                                ? 'Généré automatiquement'
                                : undefined
                        "
                        :prepend-inner-icon="
                            autoTitleEnabled ? 'mdi-creation' : undefined
                        "
                        counter
                        :maxlength="titleMaxLenght"
                        :rules="[rules.hasTitle]"
                    >
                    </v-text-field>
                </div>
            </v-col>
            <s-date-range-field
                v-if="isDisplayed('dateDeDebut') && isDisplayed('dateDeFin')"
                v-model:date-de-debut="intervention.dateDeDebut"
                v-model:date-de-fin="intervention.dateDeFin"
                :use-time="true"
                :is-required="true"
            />
        </v-row>
    </v-form>
</template>
